490    ASSIGN @E5100 TO 800
500    CLEAR @E5100
510   !
520    DIM Bin(1:20)
530    DIM Dat$[80],Lw$[20],Err$[50],Lmt_flag$(1:20)[5]
540  !
550    OUTPUT @E5100;"PRES"
560    GOSUB Setting
570    GOSUB Power_setup
580    GOSUB Set_ch1
590    GOSUB Pi_cal
591    OUTPUT @E5100;"CALCOPY 1,2"
600    CLEAR SCREEN
610    GOSUB Set_ch1_part2
620    OUTPUT @E5100;"COUC OFF"
630    GOSUB Setup_monitor
640    GOSUB Set_ch2
650    GOSUB Measurement
660  !
670    STOP
680  !
690  !
700  !
710   !  ************  SURBROUTINES  *****************
720   !
730   !  ********* DEFAULT VALUES ********
740   !
750 Default_set:  !
760    Z0=12.5
770    F_nominal=19.979  ! (MHz)
780    Span_adj=1000  ! (ppm)
790    Span_fr=100    ! (ppm)
800    Ifbw1=1000     ! (Hz)
810    Ifbw2=1000     ! (Hz)
820    Nop1=11        ! NOP for CH1
830    Nop2=201        ! NOP for CH2
840    Wait_check=100  ! WAIT TIME for Fr check after EVAPOLATION
850    RETURN
860   !
870   !
880 Default_power:  !
890    Power=10            ! POWER = 10 (uW)
900    R=10             ! CI = 10 (ohm)
910    RETURN
920    !
930    !
940 Lmt_flag:  !
950   !
960   !     Lmt,Flag
970   ! ----------------
980   DATA "0,ON","0000000000000001"  !  1
990   DATA "0,OFF"
1000  DATA "0,OFF"
1010  DATA "0,OFF"
1020  DATA "0,ON","0000000000000010"  !  2
1030  DATA "0,OFF"
1040  DATA "0,OFF"
1050  DATA "0,ON","0000000000000100"  !  4
1060  DATA "0,OFF"
1070  DATA "0,OFF"
1080  DATA "0,ON","0000000000001000"  !  8
1090 !
1100 !
1110 !
1120 !  ********************************
1130 !
1140 Setting: !
1150 !
1160  GOSUB Default_set
1170 ! OUTPUT @E5100;"OSE 16384;OSNT 16384;*SRE 128"  ! SET INTERRUPT for DATA TRANSFER between NA and EXT PC
1180  OUTPUT @E5100;"*CLS"
1190  OUTPUT @E5100;"DISAHIHB"
1200  OUTPUT @E5100;"CHAN1;HOLD"
1210  OUTPUT @E5100;"TRAP OFF"
1220  OUTPUT @E5100;"CHAN2;HOLD"
1230  OUTPUT @E5100;"TRAP OFF"
1240  OUTPUT @E5100;"CHAN1"
1250  OUTPUT @E5100;"MULC ON"
1260  OUTPUT @E5100;"COUC ON"
1270  OUTPUT @E5100;"SWPT LINF"
1280  INPUT "Nominal frequency (MHz) ?",F_nominal
1290  F_nominal=F_nominal*1.E+6
1300  INPUT "Adjustment Span (ppm) ?",Span_adj
1310  Span_adj=Span_adj/1.E+6
1320  Span_adj=F_nominal*Span_adj
1330  Startf=F_nominal
1340  Stopf=F_nominal+Span_adj
1350  INPUT "Span for Fr check (ppm) ?",Span_fr
1360  Span_fr=Span_fr/1.E+6
1370  Span_fr=F_nominal*Span_fr
1380  INPUT "IFBW at CH1 (Hz) ?",Ifbw1
1390  INPUT "IFBW at CH2 (Hz) ?",Ifbw2
1400 ! INPUT "NOP for EVAPOLATION at CH1 ? ",Nop1
1410  INPUT "NOP for Fr check at CH2 ? ",Nop2
1420  INPUT "WAIT TIME after EVAPOLATION (msec) ?",Wait_check
1430  Wait_check=Wait_check/1000
1440  EXECUTE "ANAOCH2"
1450  EXECUTE "ANAODATA"
1460  EXECUTE "ANARFULL"
1470  RETURN
1480 !
1490 !
1500 Power_setup: !
1510  GOSUB Default_power
1520  OUTPUT @E5100;"POWU WATT"
1530  OUTPUT @E5100;"PICIRC ON"
1540  INPUT "POWER (uW)",Power
1550  INPUT "RESONANT RESISTANCE (ohm) ",R
1560  Power=Power*1.E-6
1570  !
1580 !
1590 !
1600 Set_ch1:!
1610  OUTPUT @E5100;"CHAN1;ANAMODE ZTRAN;MEAS AR;FMT MAGZP"
1620  OUTPUT @E5100;"HOLD"
1630  OUTPUT @E5100;"CIVAL ";R
1640  OUTPUT @E5100;"POWE ";Power
1650  OUTPUT @E5100;"STAR ";Startf-(Span_fr)*(7/8)  ! SET START FREQ for CAL
1660  OUTPUT @E5100;"STOP ";Stopf
1670  OUTPUT @E5100;"POIN ";Nop1
1680  OUTPUT @E5100;"IFBW ";Ifbw1
1690  OUTPUT @E5100;";DISG OFF"
1700  OUTPUT @E5100;";SWED DOWN"
1710  RETURN
1720 !
1730 !
1740 Set_ch1_part2:!
1750  OUTPUT @E5100;"STAR ";Startf
1760  RETURN
1770 !
1780 !
1790 Set_ch2:!
1800  OUTPUT @E5100;"CHAN2;ANAMODE ZTRAN;MEAS AR;FMT MAGZP"
1810  OUTPUT @E5100;"HOLD"
1820  ! OUTPUT @E5100;"CIVAL ";R
1830  ! OUTPUT @E5100;"POWE ";Power
1840  ! OUTPUT @E5100;"LINFREQ"
1850  OUTPUT @E5100;"STOP ";Startf+(Span_fr)*(1/8)      ! SET STOP FREQ for CH2 based on START FREQ at CH1
1860  OUTPUT @E5100;"STAR ";Startf-(Span_fr)*(7/8)
1870  OUTPUT @E5100;"POIN ";Nop2
1880  OUTPUT @E5100;"IFBW ";Ifbw2
1890  OUTPUT @E5100;";DISG OFF"
1900  OUTPUT @E5100;"SETZ ";Z0
1910  RETURN
1920 !
1930 !
1940 !     ********** MONITOR FUNCTION SETUP ***********
1950 !
1960 Setup_monitor:!          MONITOR function setip
1970 !
1980  Start_pt=1              ! Set Start Point
1990  Stop_pt=Nop1            ! Set Stop Point
2000 !
2010  OUTPUT @E5100;"WRIT16" !  Set the Number of PIN of I/O Port
2020  !
2030  RESTORE Lmt_flag
2040  !
2050  FOR I=Start_pt TO Stop_pt
2060    READ Lmt_flag$(I)
2070    OUTPUT @E5100;"INPUTRAC "&VAL$(I)&","&Lmt_flag$(I)   ! Set I/O output Points
2080    IF Lmt_flag$(I)[3;2]="ON" THEN
2090      READ Lw$
2100      Bin(I)=DVAL(Lw$,2)
2110      OUTPUT @E5100;"INPUTRACB "&VAL$(I)&",1,";Bin(I)    ! Set I/O output info
2120    ELSE
2130      OUTPUT @E5100;"INPUTRACB "&VAL$(I)&",1,0"
2140    END IF
2150  NEXT I
2160 !
2161  OUTPUT @E5100;"TRABGE 1"
2170  OUTPUT @E5100;"TRAR ";Start_pt,Stop_pt
2180  OUTPUT @E5100;"TRAFMEMO"
2190  OUTPUT @E5100;"TRAP ON"
2200  !
2210  RETURN
2220  !
2230  !
2240  !  ********* MEASUREMENT ***********
2250  !
2260 Measurement:!
2270  !
2280  LOOP
2290    DISP "CONNECT DEVICE, and PRESS CONTINUE."
2300    PAUSE
2310    DISP "MEASURING"
2320    !
2330    OUTPUT @E5100;"UPDD OFF"
2340    OUTPUT @E5100;"CHAN1"
2350    OUTPUT @E5100;"UPDD ON"
2360    EXECUTE "SING"
2370    !
2380    WAIT Wait_check
2390    !
2400    OUTPUT @E5100;"UPDD OFF"
2410    OUTPUT @E5100;"CHAN2"
2420    OUTPUT @E5100;"UPDD ON"
2430    EXECUTE "SING"
2440    !
2450    GOSUB Analysis
2460    GOSUB Printing
2470  END LOOP
2480    !
2490  RETURN
2500    !
2510    !  ***************************************
2520    !
2530 Analysis: !
2540  EXECUTE "OUTPRESO?"
2550  Ci=READIO(8,0)
2560  Fr=READIO(8,1)
2570  RETURN
2580  !
2590  !
2600 Printing:  !
2610  CLEAR SCREEN
2620  PRINT USING "25A,4D.8D,6A";"RESONANT FREQUENCY  ";Fr/1.E+6;" (MHz)"
2630  PRINT USING "25A,5X,6D.D,6A";"RESONANT RESISTANCE ";Ci;" (ohm)"
2640  RETURN
2650 !
2660 !
2670 !
2680 !   *************** CALIBRATION *******************
2690 !
2700 Pi_cal: !
2710    !
2720  OUTPUT @E5100;";DISAHIHB"
4480  !
4811  DISP "Leave fixture open,then press 'continue'."
4812  PAUSE
4820  OUTPUT @E5100;"CLASS11A;*OPC?"
4830  ENTER @E5100;Opc
4860  !
4871  DISP "Connect short bar ,then press 'continue'."
4872  PAUSE
4880  OUTPUT @E5100;"CLASS11B;*OPC?"
4890  ENTER @E5100;Opc
4920  !
4931  DISP "Connect load,then press 'continue'."
4932  PAUSE
4940  OUTPUT @E5100;"CLASS11C;*OPC?"
4950  ENTER @E5100;Opc
4980  !
5070  OUTPUT @E5100;"SAV1"
5080  DISP ""
5090  RETURN
5100  !
5190  END
6000   !*************************************************
6010   !* DESCRIPTION:  Agilent E5100A/B Sample Program
6020   !*
6030   !* AUTHOR:       Agilent Technologies Japan, Ltd.
6040   !* CREATED:      05/01/2008
6050   !* PROGRAM NAME: SMPL022.BAS
6060   !* REVISION:     A.01.11
6070   !*
6080   !*     Copyright (c) Agilent Technologies,
6090   !*              All rights reserved.
6100   !*
6110   !*
6120   !*  Customer shall have the personal, non-
6130   !* transferable rights to use, copy or modify
6140   !* this SAMPLE PROGRAM for Customer's internal
6150   !* operations. Customer shall use the SAMPLE
6160   !* PROGRAM solely and exclusively for its own
6170   !* purpose and shall not license, lease, market
6180   !* or distribute the SAMPLE PROGRAM or
6190   !* modification or any part thereof.
6200   !*
6210   !*  Agilent Technologies shall not be liable for
6220   !* the quality, performance or behavior of the
6230   !* SAMPLE PROGRAM. Agilent Technologies especially
6240   !* disclaims that the operation of the SAMPLE
6250   !* PROGRAM shall be uninterrupted or error free.
6260   !* This SAMPLE PROGRAM is provided AS IS.
6270   !*
6280   !*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
6290   !* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
6300   !* A PARTICULAR PURPOSE.
6310   !*
6320   !*  Agilent Technologies shall not be liable for
6330   !* any infringement of any patent, trademark,
6340   !* copyright or other proprietary rights by the
6350   !* SAMPLE PROGRAM or its use. Agilent Technologies
6360   !* does not warrant that the SAMPLE PROGRAM is
6370   !* free from infringements or such rights of third
6380   !* parties. However, Agilent Technologies will not
6390   !* knowingly infringe or deliver a software that
6400   !* infringes the patent, trademark, copyright or
6410   !* other proprietary right of a third party.
6420   !*
6430   !*************************************************